<?php
require_once './functions/layoutfunction.php';
require_once './functions/tablefunctions.php';
require_once 'functions/mainfunctions.php';

$db = new MyDb();
$pagesize = 8;
get_userID($userID, $username, $db);

$kategorie  = urldecode(array_item($_REQUEST, 'kategorie'));
$znacka     = urldecode(array_item($_REQUEST, 'znacka'));
$day        = urldecode(array_item($_REQUEST, 'day'));
$page       = array_item($_REQUEST, 'page');

// platnost
if(!$page || $page<1 || !is_numeric($page))
  $page=1;
elseif($page>100)
  $page=100;

head('Inzeráty');
navigace($username);
menu_horizontal();
?>
<div id="sloupec-prostredni-pravy">
    <div id="sloupec-l">
        <div id="grafika_vrch"></div>
        <div id="grafika_stred">
            <div class="obsah">
            <?php
            if (array_item($_REQUEST, 'kategorie')){
               $sql='SELECT Kategorie from Kategorie WHERE Kategorie='.$db->sql_string($kategorie);
               if ($db->querySingleItem($sql)==(-1)) {
                    header("Location: " . baseurl() . "/index.php");
                    exit;
               }
               else {
                echo "<h2>".$kategorie.":</h2>\n";
                $sql=build_kategorie_query($kategorie, $page, $pagesize);
                $rows = $db->queryObjectArray($sql);
                show_adv($db, $rows, $pagesize);
                $query = "kategorie=".urlencode($kategorie);
                show_page_links($page, $pagesize, sizeof($rows), $query);
               }
            }
            else if (array_item($_REQUEST, 'znacka')){
               $sql='SELECT Znacka from Znacka WHERE Znacka='.$db->sql_string($znacka);
               if ($db->querySingleItem($sql)==(-1)) {
                    header("Location: " . baseurl() . "/index.php");
                    exit;
               }
               else {
                echo "<h2>".$znacka.":</h2>\n";
                $sql=build_znacka_query($znacka, $page, $pagesize);
                $rows = $db->queryObjectArray($sql);
                show_adv($db, $rows, $pagesize);
                $query = "znacka=".urlencode($znacka);
                show_page_links($page, $pagesize, sizeof($rows), $query);
               }

            }
            else if (array_item($_REQUEST, 'day') || $day='today' || $day='yesterday'){
                switch ($day){
                    case 'today':
                        echo "<h2>Dnes přidané:</h2>\n";
                        break;
                    case 'yesterday':
                        echo "<h2>Včera přidané:</h2>\n";
                        break;
                }
                $sql=build_day_query($day, $page, $pagesize);
                $rows = $db->queryObjectArray($sql);
                show_adv($db, $rows, $pagesize);
                $query = "day=$day";
                show_page_links($page, $pagesize, sizeof($rows), $query);
            }
            else {
                $sql=build_day_query('today', $page, $pagesize);
                $rows = $db->queryObjectArray($sql);
                show_adv($db, $rows, $pagesize);
                $query = "day=$day";
                show_page_links($page, $pagesize, sizeof($rows), $query);
            }
            ?>
            </div>
        </div>
    </div> <!-- Konec prostredniho sloupce -->

    <div id="sloupec-p">
    <?php
        right_navigation_1();
    ?>
    </div> <!-- Konec praveho sloupce -->
    <div class="cleaner">&nbsp;</div>
</div> <!-- Konec sloupce obalujiciho prostredni a pravy sloupec -->
<?php
menu_vertical();
foot();
// ------------ funkce --------------
function build_day_query($day, $page, $pagesize){
     switch ($day){
        case 'today':
           $sql ="SELECT `idInzerat`, `Vytvoreno` FROM Inzerat WHERE ".
           "DATE(Inzerat.Vytvoreno)=DATE(NOW()) ORDER BY Vytvoreno DESC ";
        break;
        case 'yesterday':
           $sql ="SELECT `idInzerat`, `Vytvoreno` FROM Inzerat WHERE ".
           "DATE(Inzerat.Vytvoreno)=DATE(DATE_SUB(NOW(), INTERVAL 1 DAY)) ORDER BY Vytvoreno DESC ";
           break;
     }

     $sql .= "LIMIT " . (($page-1) * $pagesize) . "," . ($pagesize + 1);
     return $sql;
}

function build_znacka_query($znacka, $page, $pagesize){
    $sql ="SELECT DISTINCT `idInzerat`, `Vytvoreno` FROM Inzerat, Udaje, Model, Znacka, ".
          "Kategorie WHERE Inzerat.Udaje_idUdaje=Udaje.idUdaje AND Udaje.Model_idMOdel=Model.idModel ".
          "AND Model.Znacka_idZnacka=Znacka.idZnacka AND ".
          "Znacka.Znacka='$znacka' ORDER BY Vytvoreno DESC ";
    
     $sql .= "LIMIT " . (($page-1) * $pagesize) . "," . ($pagesize + 1);
     return $sql;
}

function build_kategorie_query($kategorie, $page, $pagesize){
    $sql ="SELECT DISTINCT `idInzerat`, `Vytvoreno` FROM Inzerat, Udaje, Model, Znacka, ".
          "Kategorie WHERE Inzerat.Udaje_idUdaje=Udaje.idUdaje AND Udaje.Model_idMOdel=Model.idModel ".
          "AND Model.Kategorie_idKategorie=Kategorie.idKategorie AND ".
          "Kategorie.Kategorie='$kategorie' ORDER BY Vytvoreno DESC ";

     $sql .= "LIMIT " . (($page-1) * $pagesize) . "," . ($pagesize + 1);
     return $sql;
}

// zobrazeni inzerátu
function show_adv($db, $adv, $pagesize) {
  if(!$adv) {
    echo "<p>Bohužel nebyly nalezeny žádné názvy inzerátů.</p>\n";
    return; }

  // vytvoření řeězce obsahujícího inzeratID, která jsou oddělena čárkami
  $items = min($pagesize, sizeof($adv));
  for($i=0; $i<$items; $i++)
    if($i==0)
      $InzeratIDs = $adv[$i]->idInzerat;
    else
      $InzeratIDs .= "," . $adv[$i]->idInzerat;

  // získání zákloadních dat týkajících se inzerátu
    $sql ="SELECT DATE_FORMAT(Vytvoreno, '%e.%m.%Y') as Vytvoreno, `idInzerat` ,`Cena`, `Najeto`," .
        "`Vyrobeno`, `Model`, `Znacka` , `Mesto`, `Kraj`, `email`, `telefon`,  `icq` ".
        "FROM Inzerat, Udaje, Model, Znacka, Mesto, Kraj, Uzivatel WHERE Inzerat.idInzerat IN ($InzeratIDs) " .
        "AND Udaje.idUdaje=Inzerat.Udaje_idUdaje AND Model.idModel=Udaje.Model_idModel " .
        "AND Znacka.idZnacka=Model.Znacka_idZnacka AND Mesto.idMesto=(SELECT Mesto_idMesto " .
        "FROM Mesto_uzivatel WHERE Uzivatel_idUzivatel=Inzerat.Uzivatel_idUzivatel) " .
        "AND Kraj.idKraj=Mesto.Kraj_idKraj AND Uzivatel.idUzivatel=Inzerat.Uzivatel_idUzivatel ".
        "GROUP BY Vytvoreno ORDER BY Vytvoreno DESC";

  $advrows = $db->queryObjectArray($sql);

  //zobrazení tabulky
  table_result_start();
  //popis tabulky
  table_new_line(TRUE);
  table_empty_cell(1);
  table_asis('<b>Název</b>');
  table_asis('<b>Rok<br>Najeto</b>');
  table_asis('<b>Cena</b>');
  table_asis('<b>Vloženo</b>');
  table_end_line();
  $i=0;
  foreach ($advrows as $row){
      $i++;
      if ($i % 2 == 0) table_new_line(TRUE);
      else table_new_line(FALSE);
      $sql="SELECT `url_minfoto` FROM Foto WHERE idFoto= ".
           "(SELECT MIN(idFoto) FROM Foto WHERE Inzerat_idInzerat=$row->idInzerat)";
      if (($foto=$db->querySingleItem($sql))==(-1))
        table_img('show_adv.php?inzeratID='.$row->idInzerat,'./img/noFoto.jpg');
      else
        table_img('show_adv.php?inzeratID='.$row->idInzerat,$foto);

 
      table_asis('<a href="show_adv.php?inzeratID='.$row->idInzerat.'"><b>'.$row->Znacka.' '.$row->Model.'</b></a><br>'.
                    $row->Kraj.','.$row->Mesto);
      //rok + KM
      table_asis($row->Vyrobeno.'<br>'.$row->Najeto.' km');
      //cena
      table_asis($row->Cena.' Kč');
      //datum vložení
      table_asis($row->Vytvoreno);
  }
  table_result_end();
}


// zobrazí odkazy na předházející/následující stránky
// $page     .. číslo aktuální stránky
// $pagesize .. maximální počet položek na stránku
// $results  .. počet nalezených výsledků vyhledávání
function show_page_links($page, $pagesize, $results, $query) {
  if(($page==1 && $results<=$pagesize) || $results==0)
    // není co dělat
    return;
  echo "<p>Přesun na stránku: ";
  if($page>1) {
    for($i=1; $i<$page; $i++)
      echo build_href("find.php", $query . "&page=$i", $i), " ";
    echo "$page "; }
  if($results>$pagesize) {
    $nextpage = $page + 1;
    echo build_href("find.php", $query . "&page=$nextpage", $nextpage);
  }
  echo "</p>\n";
}
?>
