<?php
    
    // úvodní formulář; pouľití tabulky pro zarovnání údajů zadaných do formuláře
    function form_start($action, $method="post", $enctype="multipart/form-data") {
      echo '<table class="myformtable">', "\n",
           '<form ', html_attribute("method", $method),
                      html_attribute("action", $action),
                      html_attribute("enctype", $enctype), ">\n"; }

    // uzavření formuláře
    function form_end() {
      echo "</form></table>\n\n";
    }

    // nový řádek do tabulky
    function form_new_line() {
      echo "<tr>"; }

    // konec řádku
    function form_end_line() {
      echo "</tr>\n\n"; }

    // zobrazení textu zarovnaného vpravo v buňce formuláře
    function form_label($caption, $necessary=FALSE) {
      echo '<td align="right" class="myformtd">';
      if($necessary)
        echo '<span class="tucne">', nl2br(htmlentities($caption,ENT_COMPAT, "UTF-8")), '<span class="hvezda">*</span></span>';
      else
        echo htmlentities($caption, ENT_COMPAT, "UTF-8");
      echo '</td>', "\n";
    }

    // zobrazení textu v buňce formuláře
    function form_caption($caption, $colspan=1) {
      if($colspan>1)
        echo '<td class="myformtd" ',
          html_attribute("colspan", $colspan), '>';
      else
        echo '<td class="myformtd">';
      echo htmlentities($caption, ENT_COMPAT, "UTF-8"), '</td>', "\n";
    }

    // zobrazení textu tak, jak je v buňce formuláře
    function form_asis($txt, $colspan=1) {
      if($colspan>1)
        echo '<td class="myformtd" ',
          html_attribute("colspan", $colspan), '>';
      else
        echo '<td class="myformtd">';
      echo $txt, '</td>', "\n";
    }

    // zobrazení adresy URL v buňce formuláře
    function form_url($url, $txt, $colspan=1) {
      if($colspan>1)
        echo '<td class="myformtd" ',
          html_attribute("colspan", $colspan), '>';
      else
        echo '<td class="myformtd">';
      echo "<a href=\"$url\">" . htmlentities($txt) . "</a></td>\n";
    }

    // uloľení skrytých dat do formuláře
    function form_hidden($name, $value) {
      echo '<input type="hidden" ',
        html_attribute("name", "form[$name]"),
        html_attribute("value", $value),
        " />\n";
    }

    // vytvoření $n prázdných buněk
    function form_empty_cell($n=1) {
      echo str_repeat('<td class="myformtd">&nbsp;</td>', $n) . "\n";
    }

    // vytvoření políčka pro zadávání textu ve formuláři
    function form_text($name, $value, $size=40, $maxlength=40, $colspan=1) {
      if($colspan>1)
        echo '<td class="myformtd" ',
          html_attribute("colspan", $colspan), '>';
      else
        echo '<td class="myformtd"> ';
      echo '<input ',
        html_attribute("name", "form[$name]"),
        html_attribute("size", $size),
        html_attribute("maxlength", $maxlength);
      if($value)
        echo html_attribute("value", $value);
      echo ' /></td>', "\n";
    }

    // vytvoření políčka pro zadávání textu ve formuláři
    function form_text_popis($name, $value, $popis,$size=40, $maxlength=40, $colspan=1) {
      if($colspan>1)
        echo '<td class="myformtd" ',
          html_attribute("colspan", $colspan), '>';
      else
        echo '<td class="myformtd"> ';
      echo $popis;
      echo '<input ',
        html_attribute("name", "form[$name]"),
        html_attribute("size", $size),
        html_attribute("maxlength", $maxlength);
      if($value)
        echo html_attribute("value", $value);
      echo ' /></td>', "\n";
    }

    // vytvoření políčka pro heslo ve formuláři
    function form_password($name, $value, $size=40, $maxlength=40, $colspan=1) {
      if($colspan>1)
        echo '<td class="myformtd" ',
          html_attribute("colspan", $colspan), '>';
      else
        echo '<td class="myformtd"> ';
      echo '<input ',
        html_attribute("type", "password"),
        html_attribute("name", "form[$name]"),
        html_attribute("size", $size),
        html_attribute("maxlength", $maxlength);
      if($value)
        echo html_attribute("value", $value);
      echo ' /></td>', "\n";
    }

    // vytvoření políčka pro zadávání textu ve formuláři
    function form_textarea($name, $value, $cols=7, $rows=6, $colspan=1, $maxlength=50) {
      if($colspan>1)
        echo '<td class="myformtd" ',
          html_attribute("colspan", $colspan), '>';
      else
        echo '<td class="myformtd"> ';
      echo '<textarea ',
        html_attribute("name", "form[$name]"),
        html_attribute("rows", $rows),
        html_attribute("cols", $cols),
        html_attribute("onkeyup", "checkLength(this, $maxlength)"), '>';
      if($value)
        echo htmlspecialchars($value);
      echo '</textarea></td>', "\n";
    }

    // vytvoření políčka pro zadávání souborů ve formuláři
    function form_file($name, $size=40, $colspan=1) {
      if($colspan>1)
        echo '<td class="myformtd" ',
          html_attribute("colspan", $colspan), '>';
      else
        echo '<td class="myformtd"> ';
      echo '<input ',
        html_attribute("type", "file"),
        html_attribute("name", "form[$name]"),
        html_attribute("size", $size);
      echo ' /></td>', "\n";
    }

    // vytvoření seznamu pro výběr položek
    function form_list($name, $rows, $selected=-1, $default=FALSE) {
      if(!$default)
        $default="[vyber]";
      echo '<td class="myformtd">';
      echo '<select class="myformtd" ',
        html_attribute("name", "form[$name]"), '>', "\n";
      echo '<option value="none">', htmlentities($default, ENT_COMPAT, 'UTF-8'), '</option>';
      foreach($rows as $row) {
        echo '<option ', html_attribute("value", $row[0]);
        if($selected==$row[0])
          echo 'selected="selected" ';
        $listentry = str_replace(" ", "&nbsp;", htmlentities($row[0], ENT_COMPAT, 'UTF-8'));
        echo ">$listentry</option>\n";
      }
      echo '</select></td>', "\n";
    }

    // vytvoření tlačítka ve formuláři
    function form_button($name, $txt, $type="submit") {
      echo '<td class="myformtd"><input ',
        //html_attribute("class", "mybutton"),
        html_attribute("type", $type),
        html_attribute("value", $txt),
        html_attribute("name", "form[$name]"),
        ' /></td>', "\n";
    }

    // vytvoření name="value"
    function html_attribute($name, $value) {
      return $name . '="' . htmlspecialchars($value) . '" ';
      //převedou na odpovídající HTML entity – tedy např. < na &lt;
    }
    function show_error_msg($txt) {
      echo '<div class="chyba">', $txt, '</div>', "\n";
    }


    /*
    // úvodní formulář; pouľití tabulky pro zarovnání údajů zadaných do formuláře
    function form_start($action) {
        echo '<form method="post" ', html_attribute("action", $action), ">\n";
        echo '<fieldset>';
    }

    //ukončení formulare
    function form_end() {
        echo "</fieldset></form>\n";
    }

    // vytvoření políčka pro heslo ve formuláři
    function form_password($name, $label_caption='', $label_obligation=FALSE, $value='', $size=18, $maxlength=15) {
      echo '<p>';
      if ($label_caption)
        form_label($name, $label_caption, $label_obligation);
      echo '<input ',
        html_attribute("type", "password"),
        html_attribute("name", "form[$name]"),
        html_attribute("size", $size),
        html_attribute("maxlength", $maxlength);
      if($value)
        echo html_attribute("value", $value);
      echo ' /><br /></p>', "\n";
    }

    // vytvoření políčka pro zadávání textu ve formuláři
    function form_text($name, $label_caption='', $label_obligation=FALSE, $value='', $size=18, $maxlength=15) {
      echo '<p>';
      if ($label_caption)
        form_label($name, $label_caption, $label_obligation);
      echo '<input ',
        html_attribute("name", "form[$name]"),
        html_attribute("size", $size),
        html_attribute("maxlength", $maxlength);
      if($value)
        echo html_attribute("value", $value);
      echo ' /><br /></p>', "\n";
    }

    // vytvoření políčka pro zadávání textu ve formuláři
    function form_textarea($name, $label_caption='', $label_obligation=FALSE, $value='', $cols=20, $rows=4) {
      echo '<p>';
      if ($label_caption)
        form_label($name, $label_caption, $label_obligation);
      echo '<textarea ',
        html_attribute("name", "form[$name]"),
        html_attribute("rows", $rows),
        html_attribute("cols", $cols), '>';
      if($value)
        echo htmlspecialchars($value);
      echo '</textarea><br /></p>', "\n";
    }

    // vytvoření seznamu pro výběr položek (upravit fuknci htmlentites na UTF8)
    function form_list($name, $rows, $selected=-1, $label_caption='', $label_obligation=FALSE) {
      echo '<p>';
      if ($label_caption)
        form_label($name, $label_caption, $label_obligation);
      echo '<select  ',
        html_attribute("name", "form[$name]"), '>', "\n";
      echo '<option value="none">(choose)</option>';
      foreach($rows as $row) {
        echo '<option ', html_attribute("value", $row[1]);
        if($selected==$row[1])
          echo 'selected="selected" ';
        $listentry = str_replace(" ", "&nbsp;", htmlentities($row[0]));
        echo ">$listentry</option>\n";
      }
      echo '</select><br /></p>', "\n";
    }

    // vytvoření tlačítka ve formuláři
    function form_button($name, $txt, $type="submit") {
      echo '<p><input ',
        //html_attribute("class", "mybutton"),
        html_attribute("type", $type),
        html_attribute("value", $txt),
        html_attribute("name", "form[$name]"),
        ' /><br /></p>', "\n";
    }

    //vytvořeni labelu
    function form_label($name, $caption, $obligation=FALSE) {
      echo '<label ',
        html_attribute("for", "form[$name]");
      echo '>', "$caption";
      if ($obligation)
          echo '<span class="hvezda">*</span>';
      echo '</label><br />';
    }

    //vytvoření textu
    function form_textseparate($value='') {
      echo '<p>'. htmlspecialchars($value);
      echo '</p>', "\n";
    }

    // vytvoření name="value"
    function html_attribute($name, $value) {
      return $name . '="' . htmlspecialchars($value) . '" ';
    }
    // zobrazení chybového hláąení (červeně)
    function show_error_msg($txt) {
      echo '<div class="chyba"><p>',htmlentities($txt, ENT_QUOTES, "UTF-8"),'</p></div>', "\n";
    }
    */
?>
