<?php
require_once './functions/layoutfunction.php';
require_once '/functions/formfunctions.php';
require_once 'functions/mainfunctions.php';

$db = new MyDb();

get_userID($userID, $username, $db);
if(!$userID)  {
  header("Location: " . baseurl() . "/login.php");
  exit; }

$formdata = array_item($_POST, "form");
if(empty($formdata)) $formdata = read_user_data($userID, $db);

if(is_array($formdata)) {
  // vyhnutí se magic quotes
  if(get_magic_quotes_gpc())
    while($i = each($formdata))
      $formdata[$i[0]] = stripslashes($i[1]);
}
$edit_account=FALSE;

head(' Můj účet - Edit');
navigace($username);
menu_horizontal();
?>
<div id="sloupec-prostredni-pravy">
    <div id="sloupec-l">
        <div id="grafika_vrch"></div>
        <div id="grafika_stred">
            <div class="obsah">
                <h2>Osobní informace uživatele: <?php echo $username ?> </h2>
                <?php
                if(array_item($formdata, "btnSave")){
                      $errormsg = "";
                      if(validate_data($formdata, $errormsg, $db)) {
                        $db->execute("START TRANSACTION");
                        if(update_data($formdata, $db))
                            $db->execute("COMMIT");
                        else{
                            $db->execute("ROLLBACK");
                            echo "<p>Chyba databáze!</p>\n";
                        }
                        $edit_account = TRUE;
                        redirect(baseurl().'/usr_account.php', 5);
                      }
                      else show_error_msg($errormsg);
                  }
                  if(array_item($formdata, "btnRegion")){
                    show_form1($formdata, $db, TRUE);
                  }
                  else if($edit_account==FALSE) show_form1($formdata, $db);
                ?>
            </div>
        </div>
    </div> <!-- Konec prostredniho sloupce -->

    <div id="sloupec-p">
    <?php
        right_navigation_1();
    ?>
    </div> <!-- Konec praveho sloupce -->
    <div class="cleaner">&nbsp;</div>
</div> <!-- Konec sloupce obalujiciho prostredni a pravy sloupec -->
<?php
menu_vertical();
foot();
// ------------ funkce --------------
// zobrazeni formuláře pro editaci
function show_form1($formdata, $db, $kraj=FALSE) {
  $sql = "SELECT Kraj FROM Kraj ORDER BY Kraj ASC";
  $rows = $db->queryArray($sql);

  if($kraj || array_item($formdata, "city")<>'none' || array_item($formdata, "city")<>'[vyber]'){
    $sql_mesto = "SELECT DISTINCT Mesto FROM MESTO " .
                "WHERE Kraj_idKraj = (SELECT idKraj FROM Kraj WHERE Kraj=" .
                $db->sql_string(array_item($formdata, "region")) . ")".
                "ORDER BY Mesto ASC";
    $rows_mesto = $db->queryArray($sql_mesto);
  }
  else $rows_mesto=FALSE;

  form_start("usr_edit.php");

  // e-mail
  form_new_line();
  form_label("e-mail:", TRUE);
  form_text("email", array_item($formdata, "email"), 20, 20);
  form_hidden("username", array_item($formdata, "username"));
  form_empty_cell();
  form_end_line();

  // telefon
  form_new_line();
  form_label("telefon:", TRUE);
  form_text("telefon", array_item($formdata, "telefon"), 20, 20);
  form_empty_cell();
  form_end_line();

  // icq
  form_new_line();
  form_label("icq:", FALSE);
  form_text("icq", array_item($formdata, "icq"), 20, 20);
  form_empty_cell();
  form_end_line();

  // kraj
  form_new_line();
  form_label("region:", TRUE);
  form_list("region", $rows, array_item($formdata, "region"));
  form_button("btnRegion", "Potvrd vyber");
  form_end_line();

  // mesto
  form_new_line();
  form_label("nejbližší místo:", TRUE);
  if($rows_mesto){
    form_list("city", $rows_mesto, array_item($formdata, "city"));
  }
  form_empty_cell();
  form_end_line();

  // tlačítka
  form_new_line();
  form_empty_cell();
  form_button("btnSave", "Uprav");
  form_empty_cell();
  form_end_line();

  // konec formuláře
  form_end();
}

//naštení dat o přihlášeném uživateli
function read_user_data($userID, $db) {
  $sql ="SELECT `Nick`, `email`, `telefon`, `icq`, `Mesto`, `Kraj` " .
  "FROM Uzivatel, Mesto, Kraj WHERE idUzivatel=$userID and idMesto=" .
  "(SELECT Mesto_idMesto FROM Mesto_uzivatel WHERE Uzivatel_idUzivatel=$userID)" .
   "and idKraj=Kraj_idKraj";

  $rows = $db->queryObjectArray($sql);
  if(is_array($rows) && sizeof($rows)==1) {
    $row = $rows[0];
    $result["username"] = $row->Nick;
    $result["email"]    = $row->email;
    $result["telefon"]  = $row->telefon;
    $result["region"]   = $row->Kraj;
    $result["city"]     = $row->Mesto;
    return $result;
  }
}

// Validice dat
function validate_data($formdata, &$errormsg, $db) {
  $errormsg = "";
  $username = array_item($formdata, "username");
  $email    = array_item($formdata, "email");
  $telefon  = array_item($formdata, "telefon");
  $region   = array_item($formdata, "region");
  $city     = array_item($formdata, "city");

  // e-mailová adresa
  $regex = '/[A-Z0-9.%_-]+@[A-Z0-9._%-]+/i';
  if(strlen(trim($email))<7 || !preg_match($regex, $email)) {
    $errormsg .= "Zadejte, prosím, platnou e-mailovou adresu! <br />";
  }
  else{
    $sql="SELECT COUNT(*) FROM UZIVATEL WHERE email=". $db->sql_string($email) .
         " AND email<>(SELECT email FROM Uzivatel " .
         "WHERE Nick=" . $db->sql_string($username) .")";
    if($db->querySingleItem($sql)>0)
    $errormsg .= "Vámi vybraný e-mailje již obsazen. <br />";
  }

  if(!$telefon || $city=='[vyber]')
      $errormsg .= "Zadejte, prosím telefon! <br />";

  if(!$region || $region=='[vyber]' || $region=='none')
      $errormsg .= "Vyberte, prosím region! <br />";

  if(!$city || $city=='[vyberte]' || $city=='none')
      $errormsg .= "Vyberte, prosím mesto! <br />";

  if($city && $region){
    $sql="SELECT COUNT(*) FROM Mesto WHERE Mesto=". $db->sql_string($city) .
         " AND Kraj_idKraj=(SELECT idKraj FROM Kraj WHERE" .
         " Kraj=" . $db->sql_string($region) . ")";
    if($db->querySingleItem($sql)==0)
    $errormsg .= "Vámi vybrané město se neshoduje s regionem potvrďte výběr regionu! <br />";
  }

  // pokud se nevyskytla žádná chyba
  if($errormsg != "")
    return FALSE;
  else
    return TRUE;
}

// uložení nových přihlašovacích údajů
function update_data($formdata, $db) {
  // uloľení uživatele
  $authent  = mt_rand();
  $username = $db->sql_string(array_item($formdata, "username"));
  $password = $db->sql_string(array_item($formdata, "password1"));
  $email    = $db->sql_string(array_item($formdata, "email"));
  $telefon  = $db->sql_string(array_item($formdata, "telefon"));
  $region   = $db->sql_string(array_item($formdata, "region"));
  $city     = $db->sql_string(array_item($formdata, "city"));
  $icq      = $db->sql_string(array_item($formdata, "icq"));

  $sql = "UPDATE Uzivatel SET `email`=$email, `telefon`=$telefon, ".
         "`icq`=$icq WHERE Nick=$username";

  if(!$db->execute($sql))
    return FALSE;

  $sql = "SELECT idUzivatel FROM Uzivatel WHERE Nick=$username";
  $userID = $db->querySingleItem($sql);
  //$userID = $db->insertId();
  
  $sql = "SELECT idMesto FROM MESTO WHERE Mesto=$city";
  if (!$cityID = $db->querySingleItem($sql))
    return FALSE;

  $sql = "UPDATE Mesto_uzivatel SET `Mesto_idMesto`=$cityID WHERE ".
         "`Uzivatel_idUzivatel`=$userID";
  if(!$db->execute($sql))
    return FALSE;

  echo '<p><b>Váš účet byl aktualizován!</b></p>';
  return TRUE;
}

?>