<?php
require_once 'functions/formfunctions.php';
require_once 'functions/mainfunctions.php';
require_once 'functions/layoutfunction.php';

$db = new mydb(); // připojení k MySQL; v případě neúspěchu se objeví

//pokud je uživatel přihlášen automatické přesměrování
get_userID($userID, $username, $db);
if($userID)  {
  header("Location: " . baseurl() . "/index.php");
  exit; }

$formdata = array_item($_POST, "form");
if(is_array($formdata)) {
  // vyhnutí se magic quotes
  if(get_magic_quotes_gpc())
    while($i = each($formdata))
      $formdata[$i[0]] = stripslashes($i[1]);
}
$new_account=FALSE;
// zobrazení stránky
head("Registrace");
navigace($username);
menu_horizontal();
?>
<div id="sloupec-prostredni-pravy">
    <div id="sloupec-l">
        <div id="grafika_vrch"></div>
        <div id="grafika_stred">
            <div class="obsah">
                <?php
                  // zobrazení obou přihlašovacího formuláře
                  echo "<h2>Registrace uživatele</h2>\n";
                  if(array_item($formdata, "btnSave")){
                      $errormsg = "";
                      if(validate_data($formdata, $errormsg, $db)) {                      
                        $db->execute("START TRANSACTION");
                        if(save_data($formdata, $db))
                            $db->execute("COMMIT");
                        else{
                            $db->execute("ROLLBACK");
                            echo "<p>Chyba databáze!</p>\n";
                        }
                        $new_account = TRUE;
                        redirect(baseurl(), 15);
                      }
                      else show_error_msg($errormsg);
                  }
                  if(array_item($formdata, "btnRegion")){
                    show_form1($formdata, $db, TRUE);
                  }
                  else if($new_account==FALSE) show_form1($formdata, $db);
                ?>
            </div>
        </div>
    </div> <!-- Konec prostredniho sloupce -->

    <div id="sloupec-p">
    <?php
        right_navigation_1();
    ?>
    </div> <!-- Konec praveho sloupce -->
    <div class="cleaner">&nbsp;</div>
</div> <!-- Konec sloupce obalujiciho prostredni a pravy sloupec -->
<?php
menu_vertical();
foot();
exit;

// ------------ funkce --------------
// registrace nové uživatele
function show_form1($formdata, $db, $kraj=FALSE) {
  $sql = "SELECT Kraj FROM Kraj ORDER BY Kraj ASC";
  $rows = $db->queryArray($sql);

  if($kraj || array_item($formdata, "city")<>'none' || array_item($formdata, "city")<>'[vyber]'){
    $sql_mesto = "SELECT DISTINCT Mesto FROM MESTO " .
                "WHERE Kraj_idKraj = (SELECT idKraj FROM Kraj WHERE Kraj=" .
                $db->sql_string(array_item($formdata, "region")) . ")".
                "ORDER BY Mesto ASC";
    $rows_mesto = $db->queryArray($sql_mesto);
  }
  else $rows_mesto=FALSE;
  
  form_start("usr_registration.php");
  // uživatelské jméno
  form_new_line();
  form_label("Uživatelské jméno:", TRUE);
  form_text("username", array_item($formdata, "username"), 20, 20);
  form_empty_cell();
  form_end_line();

  // heslo
  form_new_line();
  form_label("Heslo:", TRUE);
  form_password("password1", array_item($formdata, "password1"), 20, 20);
  form_empty_cell();
  form_end_line();

  // heslo
  form_new_line();
  form_label("Heslo znovu:", TRUE);
  form_password("password2", array_item($formdata, "password2"), 20, 20);
  form_empty_cell();
  form_end_line();

  // e-mail
  form_new_line();
  form_label("e-mail:", TRUE);
  form_text("email", array_item($formdata, "email"), 20, 20);
  form_empty_cell();
  form_end_line();

  // telefon
  form_new_line();
  form_label("telefon:", TRUE);
  form_text("telefon", array_item($formdata, "telefon"), 20, 20);
  form_empty_cell();
  form_end_line();

  // icq
  form_new_line();
  form_label("icq:", FALSE);
  form_text("icq", array_item($formdata, "icq"), 20, 20);
  form_empty_cell();
  form_end_line();

  // kraj
  form_new_line();
  form_label("region:", TRUE);
  form_list("region", $rows, array_item($formdata, "region"));
  form_button("btnRegion", "Potvrd vyber");
  form_end_line();

  // mesto
  
  form_new_line();
  form_label("nejbližší místo:", TRUE);
  if($rows_mesto){
    form_list("city", $rows_mesto, array_item($formdata, "city"));
  }
  form_empty_cell();
  form_end_line();

  // tlačítka
  form_new_line();
  form_empty_cell();
  form_button("btnSave", "Vlož");
  form_empty_cell();
  form_end_line();

  // konec formuláře
  form_end();

}

// Validita dat
function validate_data($formdata, &$errormsg, $db) {
  $errormsg = "";
  $username = array_item($formdata, "username");
  $pw1      = array_item($formdata, "password1");
  $pw2      = array_item($formdata, "password2");
  $email    = array_item($formdata, "email");
  $telefon  = array_item($formdata, "telefon");
  $region   = array_item($formdata, "region");
  $city     = array_item($formdata, "city");
  
  // uživatelské jméno
  if(!$username)
    $errormsg .= "Zadejte, prosím, své uživatelské jméno! <br>";
  else {
    $sql = "SELECT COUNT(*) FROM Uzivatel " .
           "WHERE Nick=" . $db->sql_string($username) .
           "LIMIT 1";

    if($db->querySingleItem($sql)>0)
      $errormsg .= "Vámi vybrané uživatelské jméno je již obsazeno.
                   Vyberte, prosím, jiné! <br>";
  }

  // heslo
  if(!$pw1 || !$pw2 || $pw1!=$pw2)
    $errormsg .= "Zadejte, prosím, do následujících dvou políček
                  dvakrát stejné heslo! <br>";

  // e-mailová adresa
  $regex = '/[A-Z0-9.%_-]+@[A-Z0-9._%-]+/i';
  if(strlen(trim($email))<7 || !preg_match($regex, $email)) {
    $errormsg .= "Zadejte, prosím, platnou e-mailovou adresu! <br>";
  }
  else{
    $sql="SELECT COUNT(*) FROM UZIVATEL WHERE email=". $db->sql_string($email);
    if($db->querySingleItem($sql)>0)
    $errormsg .= "Vámi vybraný e-mail je již obsazen. <br />";
  }

  if(!$telefon)
      $errormsg .= "Zadejte, prosím telefon! <br>";

  if(!$region || $region=='[vyber]' || $region=='none')
      $errormsg .= "Vyberte, prosím region! <br>";

  if(!$city || $city=='[vyberte]' || $city=='none')
      $errormsg .= "Vyberte, prosím mesto! <br>";

  if($city && $region){
    $sql="SELECT COUNT(*) FROM Mesto WHERE Mesto=". $db->sql_string($city) .
         " AND Kraj_idKraj=(SELECT idKraj FROM Kraj WHERE" .
         " Kraj=" . $db->sql_string($region) . ")";
    if($db->querySingleItem($sql)==0)
    $errormsg .= "Vámi vybrané město se neshoduje s regionem potvrďte výběr regionu! <br />";
  }

  // pokud se nevyskytla žádná chyba
  if($errormsg != "")
    return FALSE;
  else
    return TRUE;
}

// uložení nových přihlašovacích údajů
function save_data($formdata, $db) {
  // uloľení uživatele
  $authent  = mt_rand();
  $username = $db->sql_string(array_item($formdata, "username"));
  $password = $db->sql_string(array_item($formdata, "password1"));
  $email    = $db->sql_string(array_item($formdata, "email"));
  $telefon  = $db->sql_string(array_item($formdata, "telefon"));
  $region   = $db->sql_string(array_item($formdata, "region"));
  $city     = $db->sql_string(array_item($formdata, "city"));
  $icq      = $db->sql_string(array_item($formdata, "icq"));

  $sql = "INSERT INTO Uzivatel (`Nick`, `email`, `telefon`, `icq`, `Heslo`, `authent`) " .
         "VALUES ($username, $email, $telefon, $icq, PASSWORD($password), '$authent')";
  if(!$db->execute($sql))
    return FALSE;
  $userID = $db->insertId();
  
  $sql = "SELECT idMesto FROM MESTO WHERE Mesto=$city";
  if (!$cityID = $db->querySingleItem($sql))
    return FALSE;

  $sql = "INSERT INTO Mesto_uzivatel (`Uzivatel_idUzivatel`, `Mesto_idMesto`)" .
         "VALUES ($userID, $cityID)";
  if(!$db->execute($sql))
    return FALSE;

  // odeslání e-mailu
  //$subject = "Vítejte ve motoinzerci moto-i.cz!";
  $msg = "Aktivujte si, prosím, svůj nový účet\r\n" .
         "ve motoinzerci tím, že do 24 hodin\r\n" .
         "klepněte na níže uvedený internetový odkaz!\r\n\r\n";
  /*
  mail(array_item($formdata, "email"),
       $subject,
       $msg . baseurl() . "/authent.php?userID=$userID&authent=$authent",
       "From: admin@moto-i.cz");
  */
  
  echo "<p><b>Následující text slouží pouze k testovacím účelům,
        aby se dalo ověřit, že systém pro přihlašování funguje správně,
        když nelze z lokálního systému odesílat e-maily.</b></p>\n";
  echo "<p>$msg<br />",
       build_href(baseurl() . "/authent.php",
                  "userID=$userID&authent=$authent",
                  "Aktivovat účet v motoinzerci"),
       "</p>\n";

  
  // odstranění starých přihlašovacích údajů, které nebyly aktivovány do 24 hodin
  $sql = "DELETE FROM Uzivatel
          WHERE active=0
          AND   ts<DATE_SUB(NOW(), INTERVAL 1 day)";
  $db->execute($sql);
  
  return TRUE;

}
?>
